const { ccclass, property, disallowMultiple } = cc._decorator;

@ccclass
@disallowMultiple
export class Test extends cc.Component {
    private static async loadRes(url: string, type: typeof cc.Asset){
        return new Promise<any>((resolve, reject) => {
            cc.loader.loadRes(url, type, (error: Error, resource: any) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve(resource);
                }
            });
        });
    }

    @property(cc.TiledMap)
    private readonly tiledMap: cc.TiledMap = null;

    protected async start() {
        const tmxAsset = await Test.loadRes("TiledMap/first", cc.TiledMapAsset);
        this.tiledMap.tmxAsset = tmxAsset;
        const objGroup = this.tiledMap.getObjectGroup("start_points");
        for (const obj of objGroup.getObjects()) {
            cc.log(`start_points/${obj.name} 的 x 为 ${obj.x}(类型${typeof obj.x})`);
            cc.log(`start_points/${obj.name} 的 dot_threshold 为 ${obj.dot_threshold}(类型${typeof obj.dot_threshold})`);
        }
        cc.error("obj 的 x 获取出来居然是 string 类型");
        cc.error("tiled地图编辑器里 dot_threshold 属性类型设的是 int，但获取出来就成了 string");
    }
}
